<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for JP_Document StructType
 * @subpackage Structs
 */
class JP_Document extends AbstractStructBase
{
    /**
     * The _
     * @var string
     */
    public $_;
    /**
     * The AllowedTypes
     * @var string
     */
    public $AllowedTypes;
    /**
     * The City
     * @var string
     */
    public $City;
    /**
     * The Mrz
     * @var string
     */
    public $Mrz;
    /**
     * The Type
     * @var string
     */
    public $Type;
    /**
     * The ExpirationDate
     * @var string
     */
    public $ExpirationDate;
    /**
     * The Country
     * @var string
     */
    public $Country;
    /**
     * The ExpeditionDate
     * @var string
     */
    public $ExpeditionDate;
    /**
     * Constructor method for JP_Document
     * @uses JP_Document::set_()
     * @uses JP_Document::setAllowedTypes()
     * @uses JP_Document::setCity()
     * @uses JP_Document::setMrz()
     * @uses JP_Document::setType()
     * @uses JP_Document::setExpirationDate()
     * @uses JP_Document::setCountry()
     * @uses JP_Document::setExpeditionDate()
     * @param string $_
     * @param string $allowedTypes
     * @param string $city
     * @param string $mrz
     * @param string $type
     * @param string $expirationDate
     * @param string $country
     * @param string $expeditionDate
     */
    public function __construct($_ = null, $allowedTypes = null, $city = null, $mrz = null, $type = null, $expirationDate = null, $country = null, $expeditionDate = null)
    {
        $this
            ->set_($_)
            ->setAllowedTypes($allowedTypes)
            ->setCity($city)
            ->setMrz($mrz)
            ->setType($type)
            ->setExpirationDate($expirationDate)
            ->setCountry($country)
            ->setExpeditionDate($expeditionDate);
    }
    /**
     * Get _ value
     * @return string|null
     */
    public function get_()
    {
        return $this->_;
    }
    /**
     * Set _ value
     * @param string $_
     * @return \StructType\JP_Document
     */
    public function set_($_ = null)
    {
        // validation for constraint: string
        if (!is_null($_) && !is_string($_)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($_, true), gettype($_)), __LINE__);
        }
        $this->_ = $_;
        return $this;
    }
    /**
     * Get AllowedTypes value
     * @return string|null
     */
    public function getAllowedTypes()
    {
        return $this->AllowedTypes;
    }
    /**
     * Set AllowedTypes value
     * @param string $allowedTypes
     * @return \StructType\JP_Document
     */
    public function setAllowedTypes($allowedTypes = null)
    {
        // validation for constraint: string
        if (!is_null($allowedTypes) && !is_string($allowedTypes)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($allowedTypes, true), gettype($allowedTypes)), __LINE__);
        }
        $this->AllowedTypes = $allowedTypes;
        return $this;
    }
    /**
     * Get City value
     * @return string|null
     */
    public function getCity()
    {
        return $this->City;
    }
    /**
     * Set City value
     * @param string $city
     * @return \StructType\JP_Document
     */
    public function setCity($city = null)
    {
        // validation for constraint: string
        if (!is_null($city) && !is_string($city)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($city, true), gettype($city)), __LINE__);
        }
        $this->City = $city;
        return $this;
    }
    /**
     * Get Mrz value
     * @return string|null
     */
    public function getMrz()
    {
        return $this->Mrz;
    }
    /**
     * Set Mrz value
     * @param string $mrz
     * @return \StructType\JP_Document
     */
    public function setMrz($mrz = null)
    {
        // validation for constraint: string
        if (!is_null($mrz) && !is_string($mrz)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($mrz, true), gettype($mrz)), __LINE__);
        }
        $this->Mrz = $mrz;
        return $this;
    }
    /**
     * Get Type value
     * @return string|null
     */
    public function getType()
    {
        return $this->Type;
    }
    /**
     * Set Type value
     * @uses \EnumType\JP_DocumentType::valueIsValid()
     * @uses \EnumType\JP_DocumentType::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $type
     * @return \StructType\JP_Document
     */
    public function setType($type = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\JP_DocumentType::valueIsValid($type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\JP_DocumentType', is_array($type) ? implode(', ', $type) : var_export($type, true), implode(', ', \EnumType\JP_DocumentType::getValidValues())), __LINE__);
        }
        $this->Type = $type;
        return $this;
    }
    /**
     * Get ExpirationDate value
     * @return string|null
     */
    public function getExpirationDate()
    {
        return $this->ExpirationDate;
    }
    /**
     * Set ExpirationDate value
     * @param string $expirationDate
     * @return \StructType\JP_Document
     */
    public function setExpirationDate($expirationDate = null)
    {
        // validation for constraint: string
        if (!is_null($expirationDate) && !is_string($expirationDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($expirationDate, true), gettype($expirationDate)), __LINE__);
        }
        $this->ExpirationDate = $expirationDate;
        return $this;
    }
    /**
     * Get Country value
     * @return string|null
     */
    public function getCountry()
    {
        return $this->Country;
    }
    /**
     * Set Country value
     * @param string $country
     * @return \StructType\JP_Document
     */
    public function setCountry($country = null)
    {
        // validation for constraint: string
        if (!is_null($country) && !is_string($country)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($country, true), gettype($country)), __LINE__);
        }
        $this->Country = $country;
        return $this;
    }
    /**
     * Get ExpeditionDate value
     * @return string|null
     */
    public function getExpeditionDate()
    {
        return $this->ExpeditionDate;
    }
    /**
     * Set ExpeditionDate value
     * @param string $expeditionDate
     * @return \StructType\JP_Document
     */
    public function setExpeditionDate($expeditionDate = null)
    {
        // validation for constraint: string
        if (!is_null($expeditionDate) && !is_string($expeditionDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($expeditionDate, true), gettype($expeditionDate)), __LINE__);
        }
        $this->ExpeditionDate = $expeditionDate;
        return $this;
    }
}
